又一波你可能不知道的 Linux 命令行网络监控工具
===============================================================================

对任何规模的业务来说，网络监控工具都是一个重要的功能。网络监控的目标可能千差万别。比如，监控活动的目标可以是保证长期的网络服务、安全保护、对性能进行排查、网络使用统计等。由于它的目标不同，网络监控器使用很多不同的方式来完成任务。比如对包层面的嗅探，对数据流层面的统计数据，向网络中注入探测的流量，分析服务器日志等。

尽管有许多专用的网络监控系统可以365天24小时监控，但您依旧可以在特定的情况下使用命令行式的网络监控器，某些命令行式的网络监控器在某方面很有用。如果您是系统管理员，那您就应该有亲身使用一些知名的命令行式网络监控器的经历。这里有一份**Linux上流行且实用的网络监控器**列表。

### 包层面的嗅探器 ###

在这个类别下，监控工具在链路上捕捉独立的包，分析它们的内容，展示解码后的内容或者包层面的统计数据。这些工具在最底层对网络进行监控、管理，同样的也能进行最细粒度的监控，其代价是影响网络I/O和分析的过程。

1. **dhcpdump**：一个命令行式的DHCP流量嗅探工具，捕捉DHCP的请求/回复流量，并以用户友好的方式显示解码的DHCP协议消息。这是一款排查DHCP相关故障的实用工具。

2. **[dsniff][1]**：一个基于命令行的嗅探、伪造和劫持的工具合集，被设计用于网络审查和渗透测试。它可以嗅探多种信息，比如密码、NSF流量（LCTT 译注：此处疑为 NFS 流量）、email消息、网络地址等。

3. **[httpry][2]**：一个HTTP报文嗅探器，用于捕获、解码HTTP请求和回复报文，并以用户友好的方式显示这些信息。（LCTT 译注：[延伸阅读](https://linux.cn/article-4148-1.html)。 ）

4. **IPTraf**：基于命令行的网络统计数据查看器。它实时显示包层面、连接层面、接口层面、协议层面的报文/字节数。抓包过程由协议过滤器控制，且操作过程全部是菜单驱动的。（LCTT 译注：[延伸阅读](https://linux.cn/article-5430-1.html)。）

	![](https://farm8.staticflickr.com/7519/16055246118_8ea182b413_c.jpg)

5. **[mysql-sniffer][3]**：一个用于抓取、解码MySQL请求相关的数据包的工具。它以可读的方式显示最频繁或全部的请求。

6. **[ngrep][4]**：在网络报文中执行grep。它能实时抓取报文，并用正则表达式或十六进制表达式的方式匹配（过滤）报文。它是一个可以对异常流量进行检测、存储或者对实时流中特定模式报文进行抓取的实用工具。

7. **[p0f][5]**：一个被动的基于包嗅探的指纹采集工具，可以可靠地识别操作系统、NAT或者代理设置、网络链路类型以及许多其它与活动的TCP连接相关的属性。

8. **pktstat**：一个命令行式的工具，通过实时分析报文，显示连接带宽使用情况以及相关的协议（例如，HTTP GET/POST、FTP、X11）等描述信息。

	![](https://farm8.staticflickr.com/7477/16048970999_be60f74952_b.jpg)

9. **Snort**：一个入侵检测和预防工具，通过规则驱动的协议分析和内容匹配，来检测/预防活跃流量中各种各样的后门、僵尸网络、网络钓鱼、间谍软件攻击。

10. **tcpdump**：一个命令行的嗅探工具，可以基于过滤表达式抓取网络中的报文，分析报文，并且在包层面输出报文内容以便于包层面的分析。他在许多网络相关的错误排查、网络程序debug、或[安全][6]监测方面应用广泛。

11. **tshark**：一个与Wireshark窗口程序一起使用的命令行式的嗅探工具。它能捕捉、解码网络上的实时报文，并能以用户友好的方式显示其内容。

### 流/进程/接口层面的监控 ###

在这个分类中，网络监控器通过把流量按照流、相关进程或接口分类，收集每个流、每个进程、每个接口的统计数据。其信息的来源可以是libpcap抓包库或者sysfs内核虚拟文件系统。这些工具的监控成本很低，但是缺乏包层面的检视能力。

12. **bmon**：一个基于命令行的带宽监测工具，可以显示各种接口相关的信息，不但包括接收/发送的总量/平均值统计数据，而且拥有历史带宽使用视图。

	![](https://farm9.staticflickr.com/8580/16234265932_87f20c5d17_b.jpg)

13. **[iftop][7]**：一个带宽使用监测工具，可以实时显示某个网络连接的带宽使用情况。它对所有带宽使用情况排序并通过ncurses的接口来进行可视化。他可以方便的监控哪个连接消耗了最多的带宽。（LCTT 译注：[延伸阅读](https://linux.cn/article-1843-1.html)。）

14. **nethogs**：一个基于ncurses显示的进程监控工具，提供进程相关的实时的上行/下行带宽使用信息。它对检测占用大量带宽的进程很有用。（LCTT 译注：[延伸阅读](https://linux.cn/article-2808-1.html)。）

15. **netstat**：一个显示许多TCP/UDP的网络堆栈的统计信息的工具。诸如打开的TCP/UDP连接书、网络接口发送/接收、路由表、协议/套接字的统计信息和属性。当您诊断与网络堆栈相关的性能、资源使用时它很有用。

16. **[speedometer][8]**：一个可视化某个接口发送/接收的带宽使用的历史趋势，并且基于ncurses的条状图进行显示的终端工具。

	![](https://farm8.staticflickr.com/7485/16048971069_31dd573a4f_c.jpg)

17. **[sysdig][9]**：一个可以通过统一的界面对各个Linux子系统进行系统级综合性调试的工具。它的网络监控模块可以监控在线或离线、许多进程/主机相关的网络统计数据，例如带宽、连接/请求数等。（LCTT 译注：[延伸阅读](https://linux.cn/article-4341-1.html)。）

18. **tcptrack**：一个TCP连接监控工具，可以显示活动的TCP连接，包括源/目的IP地址/端口、TCP状态、带宽使用等。

	![](https://farm8.staticflickr.com/7507/16047703080_5fdda2e811_b.jpg)

19. **vnStat**：一个存储并显示每个接口的历史接收/发送带宽视图（例如，当前、每日、每月）的流量监控器。作为一个后台守护进程，它收集并存储统计数据，包括接口带宽使用率和传输字节总数。（LCTT 译注：[延伸阅读](https://linux.cn/article-5256-1.html)。）

### 主动网络监控器 ###

不同于前面提到的被动的监听工具，这个类别的工具们在监听时会主动的“注入”探测内容到网络中，并且会收集相应的反应。监听目标包括路由路径、可供使用的带宽、丢包率、延时、抖动（jitter）、系统设置或者缺陷等。

20. **[dnsyo][10]**：一个DNS检测工具，能够管理跨越多达1500个不同网络的开放解析器的DNS查询。它在您检查DNS传播或排查DNS设置的时候很有用。

21. **[iperf][11]**：一个TCP/UDP带宽测量工具，能够测量两个端点间最大可用带宽。它通过在两个主机间单向或双向的输出TCP/UDP探测流量来测量可用的带宽。它在监测网络容量、调谐网络协议栈参数时很有用。一个叫做[netperf][12]的变种拥有更多的功能及更好的统计数据。

22. **[netcat][13]/socat**：通用的网络调试工具，可以对TCP/UDP套接字进行读、写或监听。它通常和其他的程序或脚本结合起来在后端对网络传输或端口进行监听。（LCTT 译注：[延伸阅读](https://linux.cn/article-1171-1.html)。）

23. **nmap**：一个命令行的端口扫描和网络发现工具。它依赖于若干基于TCP/UDP的扫描技术来查找开放的端口、活动的主机或者在本地网络存在的操作系统。它在你审查本地主机漏洞或者建立维护所用的主机映射时很有用。[zmap][14]是一个类似的替代品，是一个用于互联网范围的扫描工具。（LCTT 译注：[延伸阅读](https://linux.cn/article-2561-1.html)。）

24. ping：一个常用的网络测试工具。通过交换ICMP的echo和reply报文来实现其功能。它在测量路由的RTT、丢包率以及检测远端系统防火墙规则时很有用。ping的变种有更漂亮的界面（例如，[noping][15]）、多协议支持（例如，[hping][16]）或者并行探测能力（例如，[fping][17]）。（LCTT 译注：[延伸阅读](https://linux.cn/article-2303-1.html)。）

	![](https://farm8.staticflickr.com/7466/15612665344_a4bb665a5b_c.jpg)

25. **[sprobe][18]**：一个启发式推断本地主机和任意远端IP地址之间的网络带宽瓶颈的命令行工具。它使用TCP三次握手机制来评估带宽的瓶颈。它在检测大范围网络性能和路由相关的问题时很有用。

26. **traceroute**：一个能发现从本地到远端主机的第三层路由/转发路径的网络发现工具。它发送限制了TTL的探测报文，收集中间路由的ICMP反馈信息。它在排查低速网络连接或者路由相关的问题时很有用。traceroute的变种有更好的RTT统计功能（例如，[mtr][19]）。

### 应用日志解析器 ###

在这个类别下的网络监测器把特定的服务器应用程序作为目标（例如，web服务器或者数据库服务器）。由服务器程序产生或消耗的网络流量通过它的日志被分析和监测。不像前面提到的网络层的监控器，这个类别的工具能够在应用层面分析和监控网络流量。

27. **[GoAccess][20]**：一个针对Apache和Nginx服务器流量的交互式查看器。基于对获取到的日志的分析，它能展示包括日访问量、最多请求、客户端操作系统、客户端位置、客户端浏览器等在内的多个实时的统计信息，并以滚动方式显示。

	![](https://farm8.staticflickr.com/7518/16209185266_da6c5c56eb_c.jpg)

28. **[mtop][21]**：一个面向MySQL/MariaDB服务器的命令行监控器，它可以将成本最大的查询和当前数据库服务器负载以可视化的方式显示出来。它在您优化MySQL服务器性能、调谐服务器参数时很有用。

	![](https://farm8.staticflickr.com/7472/16047570248_bc996795f2_c.jpg)

29. **[ngxtop][22]**：一个面向Nginx和Apache服务器的流量监测工具，能够以类似top指令的方式可视化的显示Web服务器的流量。它解析web服务器的查询日志文件并收集某个目的地或请求的流量统计信息。

### 总结 ###

在这篇文章中，我展示了许多命令行式监测工具，从最底层的包层面的监控器到最高层应用程序层面的网络监控器。了解那个工具的作用是一回事，选择哪个工具使用又是另外一回事。单一的一个工具不能作为您每天使用的通用的解决方案。一个好的系统管理员应该能决定哪个工具更适合当前的环境。希望这个列表对此有所帮助。

欢迎您通过回复来改进这个列表的内容！

--------------------------------------------------------------------------------

via: http://xmodulo.com/useful-command-line-network-monitors-linux.html

作者：[Dan Nanni][a]
译者：[wwy-hust](https://github.com/wwy-hust)
校对：[wxy](https://github.com/wxy)

本文由 [LCTT](https://github.com/LCTT/TranslateProject) 原创翻译，[Linux中国](http://linux.cn/) 荣誉推出

[a]:http://xmodulo.com/author/nanni
[1]:http://www.monkey.org/~dugsong/dsniff/
[2]:http://xmodulo.com/monitor-http-traffic-command-line-linux.html
[3]:https://github.com/zorkian/mysql-sniffer
[4]:http://ngrep.sourceforge.net/
[5]:http://lcamtuf.coredump.cx/p0f3/
[6]:http://xmodulo.com/recommend/firewallbook
[7]:http://xmodulo.com/how-to-install-iftop-on-linux.html
[8]:https://excess.org/speedometer/
[9]:http://xmodulo.com/monitor-troubleshoot-linux-server-sysdig.html
[10]:http://xmodulo.com/check-dns-propagation-linux.html
[11]:https://iperf.fr/
[12]:http://www.netperf.org/netperf/
[13]:http://xmodulo.com/useful-netcat-examples-linux.html
[14]:https://zmap.io/
[15]:http://noping.cc/
[16]:http://www.hping.org/
[17]:http://fping.org/
[18]:http://sprobe.cs.washington.edu/
[19]:http://xmodulo.com/better-alternatives-basic-command-line-utilities.html#mtr_link
[20]:http://goaccess.io/
[21]:http://mtop.sourceforge.net/
[22]:http://xmodulo.com/monitor-nginx-web-server-command-line-real-time.html
